
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Overlay_widgetsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const overlay_widgets = await db.overlay_widgets.create(
            {
                id: data.id || undefined,
        
        instance_name: data.instance_name
        ||
        null
            ,
            
        config_json: data.config_json
        ||
        null
            ,
            
        x: data.x
        ||
        null
            ,
            
        y: data.y
        ||
        null
            ,
            
        width: data.width
        ||
        null
            ,
            
        height: data.height
        ||
        null
            ,
            
        z_index: data.z_index
        ||
        null
            ,
            
        is_visible: data.is_visible
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await overlay_widgets.setOverlay_profile( data.overlay_profile || null, {
            transaction,
        });
        
        await overlay_widgets.setCatalog_item( data.catalog_item || null, {
            transaction,
        });
        
        await overlay_widgets.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return overlay_widgets;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const overlay_widgetsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                instance_name: item.instance_name
            ||
            null
            ,
            
                config_json: item.config_json
            ||
            null
            ,
            
                x: item.x
            ||
            null
            ,
            
                y: item.y
            ||
            null
            ,
            
                width: item.width
            ||
            null
            ,
            
                height: item.height
            ||
            null
            ,
            
                z_index: item.z_index
            ||
            null
            ,
            
                is_visible: item.is_visible
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const overlay_widgets = await db.overlay_widgets.bulkCreate(overlay_widgetsData, { transaction });

        // For each item created, replace relation files
        

        return overlay_widgets;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const overlay_widgets = await db.overlay_widgets.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.instance_name !== undefined) updatePayload.instance_name = data.instance_name;
        
        
        if (data.config_json !== undefined) updatePayload.config_json = data.config_json;
        
        
        if (data.x !== undefined) updatePayload.x = data.x;
        
        
        if (data.y !== undefined) updatePayload.y = data.y;
        
        
        if (data.width !== undefined) updatePayload.width = data.width;
        
        
        if (data.height !== undefined) updatePayload.height = data.height;
        
        
        if (data.z_index !== undefined) updatePayload.z_index = data.z_index;
        
        
        if (data.is_visible !== undefined) updatePayload.is_visible = data.is_visible;
        
        
        updatePayload.updatedById = currentUser.id;

        await overlay_widgets.update(updatePayload, {transaction});

        
        
        if (data.overlay_profile !== undefined) {
            await overlay_widgets.setOverlay_profile(
              
              data.overlay_profile,
              
              { transaction }
            );
        }
        
        if (data.catalog_item !== undefined) {
            await overlay_widgets.setCatalog_item(
              
              data.catalog_item,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await overlay_widgets.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return overlay_widgets;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const overlay_widgets = await db.overlay_widgets.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of overlay_widgets) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of overlay_widgets) {
                await record.destroy({transaction});
            }
        });


        return overlay_widgets;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const overlay_widgets = await db.overlay_widgets.findByPk(id, options);

        await overlay_widgets.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await overlay_widgets.destroy({
            transaction
        });

        return overlay_widgets;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const overlay_widgets = await db.overlay_widgets.findOne(
            { where },
            { transaction },
        );

        if (!overlay_widgets) {
            return overlay_widgets;
        }

        const output = overlay_widgets.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.overlay_profile = await overlay_widgets.getOverlay_profile({
            transaction
        });
        
        
        output.catalog_item = await overlay_widgets.getCatalog_item({
            transaction
        });
        
        
        output.organizations = await overlay_widgets.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.overlay_profiles,
        as: 'overlay_profile',
        
        where: filter.overlay_profile ? {
          [Op.or]: [
            { id: { [Op.in]: filter.overlay_profile.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.overlay_profile.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.widget_catalog_items,
        as: 'catalog_item',
        
        where: filter.catalog_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.catalog_item.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.catalog_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.instance_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'overlay_widgets',
                        'instance_name',
                        filter.instance_name,
                    ),
                };
            }
            
            if (filter.config_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'overlay_widgets',
                        'config_json',
                        filter.config_json,
                    ),
                };
            }
            

            
            

            
            if (filter.xRange) {
                const [start, end] = filter.xRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    x: {
                    ...where.x,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    x: {
                    ...where.x,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.yRange) {
                const [start, end] = filter.yRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    y: {
                    ...where.y,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    y: {
                    ...where.y,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.widthRange) {
                const [start, end] = filter.widthRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    width: {
                    ...where.width,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    width: {
                    ...where.width,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.heightRange) {
                const [start, end] = filter.heightRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    height: {
                    ...where.height,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    height: {
                    ...where.height,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.z_indexRange) {
                const [start, end] = filter.z_indexRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    z_index: {
                    ...where.z_index,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    z_index: {
                    ...where.z_index,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_visible) {
                where = {
                    ...where,
                is_visible: filter.is_visible,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.overlay_widgets.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'overlay_widgets',
                        'instance_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.overlay_widgets.findAll({
            attributes: [ 'id', 'instance_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['instance_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.instance_name,
        }));
    }

    
};

